Package: assertive.base
Type: Package
Title: A Lightweight Core of the 'assertive' Package
Version: 0.0-9
Date: 2021-02-07
Author: Richard Cotton [aut, cre],
  Sunkyu Choi [trl],
  Ivanka Skakun [trl],
  Gergely Dar<c3><b3>czi [trl],
  Anton Antonov [trl],
  Hisham Ben Hamidane [trl],
  Anja Billing [trl],
  Aditya Bhagwat [trl],
  Rasmus B<c3><a5><c3><a5>th [trl],
  Mine Cetinkaya-Rundel [trl],
  Aspasia Chatziefthymiou [trl]
Maintainer: Richard Cotton <richierocks@gmail.com>
Authors@R: c(person("Richard", "Cotton", role = c("aut", "cre"), email =
    "richierocks@gmail.com"),
    person("Sunkyu", "Choi", role = "trl", email =
    "szc2010@qatar-med.cornell.edu"),
    person("Ivanka", "Skakun", role = "trl", email =
    "ivanka.skakun@gmail.com"),
    person("Gergely", "Dar<c3><b3>czi", role = "trl", email =
    "daroczig@rapporter.net"),
    person("Anton", "Antonov", role = "trl", email =
    "tonytonov@gmail.com"),
    person("Hisham", "Ben Hamidane", role = "trl", email =
    "hbh2002@qatar-med.cornell.edu"),
    person("Anja", "Billing", role = "trl", email =
    "anb2061@qatar-med.cornell.edu"),
    person("Aditya", "Bhagwat", role = "trl", email =
    "bhagwataditya@gmail.com"),
    person("Rasmus", "B<c3><a5><c3><a5>th", role = "trl", email =
    "rasmus.baath@lucs.lu.se"),
    person("Mine", "Cetinkaya-Rundel", role = "trl", email =
    "mine@stat.duke.edu"),
    person("Aspasia", "Chatziefthymiou", role = "trl", email =
    "asc2006@qatar-med.cornell.edu"))
Description: A minimal set of predicates and assertions used by the assertive
    package.  This is mainly for use by other package developers who want to
    include run-time testing features in their own packages.  End-users will
    usually want to use assertive directly.
URL: https://bitbucket.org/richierocks/assertive.base
BugReports: https://bitbucket.org/richierocks/assertive.base/issues
Depends: R (>= 3.5.0)
Imports: methods, utils
Suggests: testthat
License: GPL (>= 3)
LazyLoad: yes
LazyData: yes
Acknowledgments: Development of this package was partially funded by
        the Proteomics Core at Weill Cornell Medical College in Qatar
        <https://qatar-weill.cornell.edu>.  The Core is supported by
        'Biomedical Research Program' funds, a program funded by Qatar
        Foundation. Ukranian translations were supported by
        www.coupofy.com.
RoxygenNote: 7.1.1
ByteCompile: true
NeedsCompilation: no
Packaged: 2021-02-08 00:11:07 UTC; richie
Repository: CRAN
Date/Publication: 2021-02-08 05:50:02 UTC

[![Project Status: Active - The project has reached a stable, usable state and is being actively developed.](https://www.repostatus.org/badges/0.1.0/active.svg)](https://www.repostatus.org/#active)
[![Is the package on CRAN?](https://www.r-pkg.org/badges/version/assertive.base)](https://www.r-pkg.org/pkg/assertive.base)
[![SemaphoreCI Build Status](https://semaphoreci.com/api/v1/projects/01fd8743-d3d2-42ad-b63d-e94c5844e951/635080/badge.svg)](https://semaphoreci.com/richierocks/assertive-base)
[![AppVeyor Build Status](https://ci.appveyor.com/api/projects/status/ubs74w5tm2mxgfne?svg=true)](https://ci.appveyor.com/project/richierocks/assertive-base)

# assertive.base

A minimal set of predicates and assertions used by *[assertive](https://bitbucket.org/richierocks/assertive)*, 
for package developers who want to include run-time testing features in their own packages.  Most of the documentation is on the assertive page.  End-users will usually want to use *assertive* directly.


### Installation

To install the stable version, type:

```{r}
install.packages("assertive.base")
```

To install the development version, you first need the *devtools* package.

```{r}
install.packages("devtools")
```

Then you can install the *assertive.base* package using

```{r}
library(devtools)
install_bitbucket("richierocks/assertive.base")
```

### Predicates

There are six functions that accept (expressions resolving to) logical vectors,
and return logical vectors:

`is_true` returns a logical vector that is `TRUE` when the input is `TRUE`
(`x & !is.na(x)`).

`is_false` returns a logical vector that is `TRUE` when the input is `FALSE`
(`!x & !is.na(x)`).

`is_na` returns a logical vector that is `TRUE` when the input is `NA`
(a wrapper to `is.na(x)`).

...and their negations:

`is_not_true` returns a logical vector that is `TRUE` when the input is `FALSE` 
or `NA` (`x | is.na(x)`).

`is_not_false` returns a logical vector that is `TRUE` when the input is `TRUE` 
or `NA` (`!x | is.na(x)`).

`is_not_na` returns a logical vector that is `TRUE` when the input is `TRUE` 
or `FALSE` (`!is.na(x)`).

There are four functions that return single logical values:

`is_identical_to_true` returns `TRUE` is effectively `identical(x, TRUE)` (like 
`isTRUE`), but it lets you choose whether or not attributes are allowed on `x`.

`is_identical_to_false` and `is_identical_to_na` works similarly with `FALSE` 
and `NA`.

`are_identical` wraps `base::identical`, checking if two expressions return the 
same thing.

### Assertions

Predicates that return a vector have two corresponding assertions.  For example,
`is_true` has `assert_all_are_true` and `assert_any_are_true`.

Predicates returning a single logical value have one corresponding assertion.
For example, `is_identical_to_true` has `assert_is_identical_to_true`.

### Utilities

`use_first` takes the first value of a vector, warning you if it one longer than 
length one.

`coerce_to` is a wrapper to `as`, changing an object's type with a warning.

`get_name_in_parent` gets the name of a variable in the parent environment 
(stopping you have to remember `deparse(substitute())` arcana).

`strip_attributes` strips the attributes from an object.

`merge_dots_with_list` merges the contents of `...` with a list argument, to 
allow users to pass arguments to your function in either form.

`dont_stop` runs code without stopping at errors, which is useful for 
demonstrating errors in examples.

`parenthesise` wraps a string in parentheses.

`bapply` is a wraps `vapply`, always returning a logical vector.

#' @rdname Truth
#' @export
assert_all_are_false <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are not all FALSE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_false, 
    x, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )        
}

#' @rdname Truth
#' @export
assert_any_are_false <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are never FALSE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_false, 
    x, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )       
}
#' @rdname Truth
#' @export
assert_all_are_na <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are not all NA.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_na, 
    x, 
    coerce_to_logical = FALSE, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )   
}

#' @rdname Truth
#' @export
assert_any_are_na <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are never NA.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_na, 
    x, 
    coerce_to_logical = FALSE, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )       
}

#' @rdname Truth
#' @export
assert_all_are_true <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are not all TRUE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_true, 
    x, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_any_are_true <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                     
  msg <- gettextf(
    "The values of %s are never TRUE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_true, 
    x, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )        
}

# Negations

#' @rdname Truth
#' @export
assert_all_are_not_false <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are sometimes FALSE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_not_false, 
    x, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_any_are_not_false <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are all FALSE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_not_false, 
    x, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_all_are_not_na <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are sometimes NA.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_not_na, 
    x, 
    coerce_to_logical = FALSE, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_any_are_not_na <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are all NA.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  
  assert_engine(
    is_not_na, 
    x, 
    coerce_to_logical = FALSE, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_all_are_not_true <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are sometimes TRUE.",
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_not_true, 
    x, 
    msg = msg, 
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_any_are_not_true <- function(x, 
  severity = getOption("assertive.severity", "stop"))
{                                                      
  msg <- gettextf(
    "The values of %s are all TRUE.", 
    get_name_in_parent(x), 
    domain = "R-assertive.base"
  )
  assert_engine(
    is_not_true, 
    x, 
    msg = msg, 
    what = "any",
    .xname = get_name_in_parent(x), 
    severity = severity
  )
}

#' Get or set the \code{"cause"} attribute
#'
#' Gets or sets the \code{"cause"} (of failure) attribute of a variable.
#'
#' @param x Any variable.
#' @param value Passed to \code{gettextf} and stored in the \code{"cause"}
#' attribute.
#' @return The get method returns the \code{"cause"} attribute.
#' @seealso \code{\link{set_cause}}
#' @examples
#' # Scalar case
#' yn <- is_identical_to_true(FALSE)
#' cause(yn)
#' 
#' # Vector case
#' yn <- is_true(c(TRUE, FALSE, NA))
#' cause(yn)
#' @export
cause <- function(x)
{
  y <- attr(x, "cause")
  if(is.null(y))
  {
    return(noquote(character(length(x))))
  }
  y
}

#' @rdname cause
#' @export
`cause<-` <- function(x, value)
{
  # Can't use is_scalar here due to dependency on this
  if(length(value) != 1 && length(value) != length(x))
  {
    stop(
      sprintf(
        "The length of value should be 1 or the length of x (%d) but is %d.", 
        length(x),
        length(value)
      )
    )
  }
  attr(x, "cause") <- noquote(as.character(value))
  x
}

#' Set a cause and return the input
#' 
#' Sets the cause attribute of an object and returns that object.
#' @param x A variable.
#' @param false_value A character vector to set the cause to, where \code{x} is
#' \code{FALSE}.
#' @param missing_value A character vector to set the cause to, where \code{x} is
#' \code{NA}.
#' @details If \code{x} is \code{TRUE} everywhere, this returns the input 
#' without setting a cause.  Otherwise, the cause is an empty string where 
#' \code{x} is \code{TRUE}, \code{false_value} where it is \code{FALSE}, and
#' \code{missing_value} where it is \code{NA}.
#' @return \code{x}, with a new cause attribute.
#' @seealso \code{\link{cause}}, \code{\link[stats]{setNames}}
#' @export
set_cause <- function(x, false_value, missing_value = "missing")
{
  if(!anyNA(x) && all(x, na.rm = TRUE)) # fast version of all(!is.na(x) & x)
  {
    return(x)
  }
  is_na_x <- is.na(x)
  len_x <- length(x)
  # TRUEs
  cause_value <- character(len_x)
  # NAs
  if(length(missing_value) == 1)
  {
    cause_value[is_na_x] <- missing_value
  } else
  {
    missing_value <- rep_len(missing_value, len_x)
    cause_value[is_na_x] <- missing_value[is_na_x]
  }
  # FALSEs
  false_index <- !(x | is_na_x) # more efficient to calc than !x & !is_na_x
  if(length(false_value) == 1)
  {
    cause_value[false_index] <- false_value
  } else
  {
    false_value <- rep_len(false_value, len_x)
    cause_value[false_index] <- false_value[false_index]
  }
  cause(x) <- cause_value
  class(x) <- c("vector_with_cause", "logical")
  x
}

#' @rdname print.vector_with_cause
#' @method print scalar_with_cause
#' @export
print.scalar_with_cause <- function(x, ...)
{
  if(length(x) != 1L)
  {
    stop("x is malformed; it should have length 1.", domain = NA) 
  }
  print(x[1])
  cat("Cause of failure: ", cause(x), "\n")
}    

#' Print methods for objects with a cause attribute
#' 
#' Prints objects of class \code{scalar_with_cause} and 
#' \code{vector_with_cause}.
#' @param x an object of class \code{scalar_with_cause} or
#' \code{vector_with_cause}.
#' @param na_ignore A logical value.  If \code{FALSE}, \code{NA} values
#' are printed; otherwise they do not.  Like \code{na.rm} in many
#' stats package functions, except that the position of the failing
#' values does not change.
#' @param n_to_show A natural number.  The maximum number of failures 
#' to show. 
#' @param ... Currently unused.
#' @method print vector_with_cause
#' @importFrom utils head
#' @export
print.vector_with_cause <- function(x, na_ignore = FALSE, n_to_show = 10, ...)
{
  cause_x <- cause(x)
  names_x <- names(x)
  if(is.null(names_x))
  {
    names_x <- character(length(x))
  }
  x <- strip_attributes(x)
  ok <- if(na_ignore)
  {
    # ok can be TRUE or NA; FALSE is bad
    x | is.na(x)
  } else
  {
    # ok can be TRUE; FALSE or NA is bad
    x & !is.na(x)
  }
  
  # Append first few failure values and positions to the error message.
  fail_index <- which(!ok)
  n <- length(fail_index)
  fail_index <- head(fail_index, n_to_show)
  failures <- data.frame(
    Position = fail_index,
    Value    = truncate(names_x[fail_index]),
    Cause    = unclass(cause_x[fail_index]), # See bug 15997
    row.names = seq_along(fail_index)
  )
  # Slightly convoluted way of creating message done to ensure that xgettext
  # creates all the translation strings
  msg_showing_first <- if(nrow(failures) < n) 
  {
    paste0(
      " ", 
      gettextf(
        "(showing the first %d)", 
        nrow(failures), 
        domain = "R-assertive.base"
      )
    )
  } else ""
  msg_n_failures <- ngettext(
    n,
    "There was %d failure%s:\n",
    "There were %d failures%s:\n",
    domain = "R-assertive.base"
  )
  cat(enc2utf8(sprintf(msg_n_failures, n, msg_showing_first)))
  print(failures)
}

#' Condition classes
#' 
#' Error, warning, and message classes derived from their simple equivalents.
#' @param message A string describing the problem.
#' @param call A call describing the source of the condition.
#' @param predicate_name A string naming the predicate that was called when the 
#' condition occured.
#' @return An object of class \code{assertionError}, \code{assertionWarning}, or
#' \code{assertionMessage}.
#' @note These objects behave the same as the standard-issue \code{simpleError},
#' \code{simpleWarning}, and \code{simpleMessage} objects from base-R.  The
#' extra class allows you to provide custom handling for assertions inside 
#' \code{tryCatch}.
#' @examples 
#' tryCatch(
#'   assert_all_are_true(FALSE), 
#'   error = function(e) 
#'   {
#'     if(inherits(e, "assertionCondition"))
#'     {
#'       # Handle assertions
#'       message("This is an assertion condition.")
#'       
#'       # Handle assertions cause by a specific predicate
#'       if(e$predicate_name == "is_true")
#'       {
#'       }
#'     } else
#'     {
#'       # Handle other error types
#'     }
#'   }
#' )
#' @export
assertionError <- function(message, call = NULL, predicate_name = NULL)
{
  aerr <- list(
    message = as.character(message), 
    call = call,
    predicate_name = predicate_name
  )
  class(aer) <- c(
    "assertionError", "assertionCondition", 
    "simpleError", "error", "condition"
  )
  aerr
}

#' @rdname assertionError
#' @export
assertionWarning <- function(message, call = NULL, predicate_name = NULL)
{
  awrn <- list(
    message = as.character(message), 
    call = call,
    predicate_name = predicate_name
  )
  class(awrn) <- c(
    "assertionWarning", "assertionCondition", 
    "simpleWarning", "warning", "condition"
  )
  awrn
}

#' @rdname assertionError
#' @export
assertionMessage <- function(message, call = NULL, predicate_name = NULL)
{
  amsg <- list(
    message = as.character(message), 
    call = call,
    predicate_name = predicate_name
  )
  class(amsg) <- c(
    "assertionMessage", "assertionCondition", 
    "simpleMessage", "message", "condition"
  )
  amsg
}

test_that(
  "assertionError returns a simpleError with extra classes", {
    expected <- structure(
      list(message = "Uh-oh!", call = NULL, predicate_name = NULL),
      class = c(
        "assertionError", "assertionCondition", 
        "simpleError", "error", "condition"
      )
    )
    actual <- assertionError("Uh-oh!")
    expect_identical(actual, expected)
  }
)

test_that(
  "assertionWarning returns a simpleWarning with extra classes", {
    expected <- structure(
      list(message = "Uh-oh!", call = NULL, predicate_name = NULL),
      class = c(
        "assertionWarning", "assertionCondition", 
        "simpleWarning", "warning", "condition"
      )
    )
    actual <- assertionWarning("Uh-oh!")
    expect_identical(actual, expected)
  }
)

test_that(
  "assertionMessage returns a simpleMessage with extra classes", {
    expected <- structure(
      list(message = "Uh-oh!", call = NULL, predicate_name = NULL),
      class = c(
        "assertionMessage", "assertionCondition", 
        "simpleMessage", "message", "condition"
      )
    )
    actual <- assertionMessage("Uh-oh!")
    expect_identical(actual, expected)
  }
)

#' Are the inputs identical?
#' 
#' Checks if the inputs are identical.
#' @param x An R object or expression.
#' @param y Another R object or expression.
#' @param allow_attributes If \code{TRUE}, The attributes of \code{x} and 
#' \code{y} are allowed to differ.
#' @param ... Some R expressions, deprecated.
#' @param l A list of R expressions, deprecated.
#' @param .xname Not intended to be used directly.
#' @param .yname Not intended to be used directly.
#' @param severity How severe should the consequences of the assertion be?  
#' Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.
#' @return \code{are_identical} returns \code{TRUE} if \code{x} and \code{y} 
#' are identical.  The \code{assert_*} function throws an error on failure.
#' 
#' The legacy function \code{are_identical_legacy} allows an arbitrary number
#' of inputs and returns a symmetric square logical matrix which is \code{TRUE} 
#' where pairs of inputs are identical.  (The new version of the function 
#' is easier to work with, and it is recommended that you switch your code to 
#' it.)
#' @seealso \code{\link[base]{identical}}, 
#' \code{\link[assertive.properties]{are_same_length}}
#' @examples
#' x <- 1:5
#' are_identical(c(1, -1), cos(c(0, pi)))
#' assertive.base::dont_stop(assert_are_identical(c(1, 1), cos(c(0, pi))))
#' @export
are_identical <- function(x, y, allow_attributes =FALSE,
  .xname = get_name_in_parent(x), .yname = get_name_in_parent(y))
{  
  if(allow_attributes) 
  {
    x <- strip_attributes(x)
    y <- strip_attributes(y)
  }
  if(!identical(x, y))
  {
    return(
      false(
        gettext("%s and %s are not identical."),
        .xname,
        .yname
      )
    )
  }
  TRUE
}



#' @rdname are_identical
#' @export
are_identical_legacy <- function(..., l = list())
{
  envir <- parent.frame()
  inputs <- as.list(match.call())[-1]
  inputs_in_list <- as.list(inputs$l)[-1]
  inputs <- c(inputs[names(inputs) != "l"], inputs_in_list)
  input_pairs <- expand.grid(expr1 = inputs, expr2 = inputs)
  identicality <- apply(
    input_pairs, 
    1, 
    function(row)
    {       
      with(
        row, 
        identical(
          eval(expr1, envir = envir),
          eval(expr2, envir = envir)
        )
      )
    }
  )
  matrix(
    identicality,
    nrow     = nargs(),
    dimnames = list(inputs, inputs) 
  )
}

test_that(
  "test are_identical with identical objects returns true", 
  {
    expect_true(are_identical((1:3) ^ 3, c(1, 8, 27)))
  }
)

test_that(
  "test are_identical with non-identical objects returns false", 
  {
    expect_false(are_identical((1:3) ^ 3, c(1, 8, 27.0000001)))
  }
)

#' Wrapper to vapply that returns booleans
#' 
#' Wrapper to \code{\link{vapply}} for functions that return a boolean (logical 
#' scalar) value.
#' 
#' @param x A vector (atomic or list).
#' @param predicate A predicate (function that returns a bool) to apply.
#' elementwise to \code{x}.
#' @param ... Passed to \code{vapply}.
#' @return A logical vector.
#' @note \code{USE.NAMES} is set to \code{TRUE}
#' @seealso \code{\link{vapply}}.
#' @export
bapply <- function(x, predicate, ...)
{
  vapply(x, predicate, logical(1L), ..., USE.NAMES = TRUE)
}

#' Call a function, and give the result names.
#'
#' Calls a function, and names the result with the first argument.
#'
#' @param fn A function to call.  See note below.
#' @param x The first input to \code{fn}.
#' @param ... Optional additional inputs to \code{fn}.
#' @return The result of \code{fn(x, ...)}, with names given by the
#' argument \code{x}.
#' @note The function, \code{fn}, should return an object with the 
#' same length as the input \code{x}.  For speed and simplicity, this
#' isn't checked; it is up to the developer of the assertion to make
#' sure that this condition holds.
#' @examples
#' call_and_name(is.finite, c(1, Inf, NA))
#' 
#' # Make sure that the output is the same size as the input.
#' # Don't do this:
#' dont_stop(call_and_name(isTRUE, list(TRUE, FALSE, NA)))
#' # Do this instead:
#' call_and_name(
#'   Vectorize(isTRUE, SIMPLIFY = FALSE),
#'   list(TRUE, FALSE, NA)
#' )
#' @seealso \code{\link{cause}} and \code{\link{na}}.
#' @export
call_and_name <- function(fn, x, ...)
{
  y <- fn(x, ...)
  dim(y) <- dim(x)
  names(y) <- to_names(x)
  y
}

# Lots of issues about how best to generate names!
# Original behaviour was to use as.character everywhere, but high precision
# wanted for numbers, so behaviour was changed to use format.  This breaks 
# lots of tests.  Here are the requirements.
# - For atomic vectors, NA values should be given a missing name, not "NA"
#   -> Can't use deparse, format
# - Numbers should be given to high precision (inc complex)
#   -> Can't use as.character on numbers
# - Character vectors shouldn't be quoted
#   -> Can't use deparse
# - Recursive variables should just be a deparse, but exact details not too fussy (too rare)
to_names <- function(x)
{
  # special handling for double, complex only
  # is.vector to prevent matching to POSIXct
  if(is.double(x) && is.vector(x))
  {
    ifelse(is.na(x), NA_real_, sprintf("%.17g", x))
  } else if(is.complex(x))
  {
    ifelse(is.na(x), NA_complex_, sprintf("%.17g+%.17gi", Re(x), Im(x)))
  } else
  {
    as.character(x)
  }
}

#' Run code without stopping
#' 
#' Runs code without stopping for warnings or errors.
#' @param expr Code to execute.
#' @return A list containing the results of evaluating each call in \code{expr}.
#' @note This function is dangerous, since it overrides warnings and errors.
#' Its intended use is for documenting examples of warnings and errors.
#' @seealso \code{\link[base]{warning}} and \code{\link[base]{stop}} for 
#' generating warnings and errors respectively; \code{\link[base]{try}} and
#' \code{\link[base]{conditions}} for handling them.
#' @examples
#' dont_stop({
#'   warning("a warning")
#'   x <- 1
#'   stop("an error")
#'   y <- sqrt(exp(x + 1))
#'   assert_is_identical_to_true(y)
#'   y > 0
#' })
#' @export
dont_stop <- function(expr)
{
  this_env <- sys.frame(sys.nframe())
  
  # Split the expression up into a list of calls
  subbed_expr <- substitute(expr, this_env)
  # Temporarily wrap expr in braces, if it isn't already
  brace <- quote(`{`)
  if(!identical(subbed_expr[[1L]], brace))
  {
    subbed_expr <- c(brace, subbed_expr)
  }
  call_list <- as.list(subbed_expr)[-1L] # -1 to ignore brace again
  names(call_list) <- vapply(call_list, safe_deparse, character(1))
  
  handler <- function(e)
  {
    e["call"] <- list(NULL) # Override the condition's call
    e
  }
  
  # Evaluate each one in turn
  lapply(
    call_list,
    function(calli)
    {
      tryCatch(eval(calli, this_env), warning = handler, error = handler)
    }
  )
}

#' Get the name of a variable in the parent frame
#'
#' Gets the name of the input in the parent frame.
#'
#' @param x Variable to get the name of.
#' @param escape_percent Logical. If \code{TRUE}, percent signs are doubled, 
#' making the value suitable for use with \code{sprintf} (and hence by 
#' \code{false} and \code{na}).
#' @return A string giving the name of the input in the parent frame.
#' @examples 
#' outside <- 1
#' f <- function(inside, escape_percent) 
#' {
#'   get_name_in_parent(inside, escape_percent)
#' }
#' f(outside, TRUE) 
#' f('10%', TRUE) 
#' f('10%', FALSE)
#' @export
get_name_in_parent <- function(x, escape_percent = TRUE)
{  
  xname <- safe_deparse(
    do.call(
      substitute, 
      list(substitute(x), parent.frame())
    )
  )
  if(escape_percent)
  {
    xname <- gsub("%", "%%", xname)
  }
  xname
}

#' Merge two lists
#' 
#' Merges two lists, taking duplicated elements from the first list.
#' @param x A list.
#' @param y A list.
#' @param warn_on_dupes \code{TRUE} or \code{FALSE}.  Should a warning be given 
#' if both \code{x} and \code{y} have elements with the same name.  See note.
#' @param allow_unnamed_elements \code{TRUE} or \code{FALSE}. Should unnamed
#' elements be allowed?
#' @param ... Ignored.
#' @return A list, combining elements from \code{x} and \code{y}.
#' @note In the event of elements that are duplicated between \code{x} and 
#' \code{y}, the versions from \code{x} are used.
#' @seealso \code{\link{merge_dots_with_list}}, \code{\link[base]{merge}}
#' @examples
#' merge(
#'   list(foo = 1, bar = 2, baz = 3), 
#'   list(foo = 4, baz = 5, quux = 6)
#' )
#' 
#' # If unnamed elements are allowed, they are included at the end
#' merge(
#'   list("a", foo = 1, "b", bar = 2, baz = 3, "c"), 
#'   list(foo = 4, "a", baz = 5, "b", quux = 6, "d"),
#'   allow_unnamed_elements = TRUE
#' )
#' @method merge list
#' @export
merge.list <- function(x, y, warn_on_dupes = TRUE, allow_unnamed_elements = FALSE, ...)
{
  if(length(y) == 0) return(x)
  y <- coerce_to(y, "list", get_name_in_parent(y))
  
  # Get elements without names
  x_is_unnamed <- names_never_null(x) == ""
  y_is_unnamed <- names_never_null(y) == ""
  if(allow_unnamed_elements)
  {
    unnamed_values <- c(x[x_is_unnamed], y[y_is_unnamed])
    x <- x[!x_is_unnamed]
    y <- y[!y_is_unnamed]
  } else # !allow_unnamed_elements
  {
    if(any(x_is_unnamed) || any(y_is_unnamed))
    {
      stop("There are unnamed elements in x or y, but allow_unnamed_elements = FALSE.")
    }
  }
  
  # Now deal with named elements
  all_names <- c(names(x), names(y))
  all_values <- c(x, y)
  if(anyDuplicated(all_names) > 0)
  {
    if(warn_on_dupes)
    {
      warning(
        "Duplicated arguments: ", 
        toString(all_names[duplicated(all_names)])
      )
    }
    all_values <- all_values[!duplicated(all_names)]
  }
  if(allow_unnamed_elements)
  {
    all_values <- c(all_values, unnamed_values)
  }
  all_values
}

#' Merge ellipsis args with a list.
#'
#' Merges variable length ellipsis arguments to a function with a list argument.
#'
#' @param ... Some inputs.
#' @param l A list.
#' @param warn_on_dupes \code{TRUE} or \code{FALSE}.  Should a warning be given 
#' if both \code{x} and \code{y} have elements with the same name.  See note.
#' @param allow_unnamed_elements \code{TRUE} or \code{FALSE}. Should unnamed
#' elements be allowed?
#' @note If any arguments are present in both the \code{...} and \code{l} 
#' arguments, the \code{...} version takes preference, and a warning is thrown.
#' @return A list containing the merged inputs.
#' @seealso \code{\link{merge.list}}, \code{\link[base]{merge}}
#' @examples
#' merge_dots_with_list(
#'   foo = 1, 
#'   bar = 2, 
#'   baz = 3, 
#'   l = list(foo = 4, baz = 5, quux = 6)
#' )
#' @export
merge_dots_with_list <- function(..., l = list(), warn_on_dupes = TRUE, allow_unnamed_elements = FALSE)
{
  dots <- list(...)
  l <- coerce_to(l, "list", get_name_in_parent(l))
  merge(dots, l, warn_on_dupes = warn_on_dupes, allow_unnamed_elements = allow_unnamed_elements)
}

#' Wrap a string in brackets
#'
#' Parenthesise a character vector by wrapping elements in brackets, 
#' dashes or commas.
#' @param x Character vector to wrap in parenthenses.
#' @param type String naming the type of parenthesis.
#' @return A character vector of the input wrapped in parentheses.
#' @note English grammar terminology is awfully confusing.  The verb 'to 
#' parenthesise' means to wrap a phrase in brackets or dashes or commas,
#' thus denoting it as supplementary material that could be left out.
#' A 'parenthesis' as a noun is often used as a synonym for a round bracket.
#' @seealso \code{\link[base]{sQuote}}
#' @examples
#' paste("There were three", parenthesise(3), "mice in the experiment.")
#' paste(
#'   "I love parmos", 
#'   parenthesise("Teesside's finest culinary invention", "en_dashes"), 
#'   "but they are sure to give me heart disease."
#' )
#' parenthesise(letters[1:5], "curly")
#' paste0(
#'   "The R language", 
#'   parenthesise("an offshoot of S and Scheme", "commas"), 
#'   "is quite good for data analysis."
#' )
#' @export
parenthesize <- function(x, 
  type = c("round_brackets", "square_brackets", "curly_brackets", "angle_brackets", "chevrons", "hyphens", "en_dashes", "em_dashes", "commas")) 
{
  type <- match.arg(type)
  x <- coerce_to(x, "character", get_name_in_parent(x))
  before <- switch(
    type,
    round_brackets  = "(",
    square_brackets = "[",
    curly_brackets  = "{",
    angle_brackets  = "<",
    chevrons        = "\u3008",
    hyphens         = "- ",
    en_dashes       = "\u2013 ",
    em_dashes       = "\u2014",
    commas          = ", "
  )
  after <- switch(
    type,
    round_brackets  = ")",
    square_brackets = "]",
    curly_brackets  = "}",
    angle_brackets  = ">",
    chevrons        = "\u3009",
    hyphens         = " -",
    en_dashes       = " \u2013",
    em_dashes       = "\u2014",
    commas          = ", "
  )
  paste0(before, x, after)
}

#' @rdname parenthesize
#' @export
parenthesise <- parenthesize

#' Print a variable and capture the output
#' 
#' Prints a variable and captures the output, collapsing the value to a single 
#' string.
#' @param x A variable.
#' @param ... Arguments passed to \code{\link[base]{print}} methods.
#' @return A string.
#' @seealso \code{\link[base]{print}}, \code{\link[utils]{capture.output}}
#' @examples
#' # This is useful for including data frames in warnings or errors
#' message("This is the sleep dataset:\n", print_and_capture(sleep))
#' @importFrom utils capture.output
#' @export
print_and_capture <- function(x, ...)
{
  # call to enc2utf8 is a workaround for
  # https://bugs.r-project.org/bugzilla3/show_bug.cgi?id=16539
  enc2utf8(paste(capture.output(print(x, ...)), collapse = "\n"))
}

#' Safe version of deparse
#' 
#' A version of \code{\link[base]{deparse}} that is guaranteed to always return 
#' a single string.
#' @param expr Any R expression.
#' @param ... Passed to \code{\link[base]{deparse}}.
#' @return A character vector or length one.
#' @note By default the RStudio IDE truncates output in the console at 1000 
#' characters.  Consequently, if you use \code{safe_deparse} on large or complex
#' objects, you won't see the full value. You can change the setting using
#' Tools -> "Global Options..." -> Code -> Display -> Console -> "Limit length
#' of lines displayed in console to:".
#' @examples
#' # safe_deparse only differs from deparse when the deparse string is longer
#' # than width.cutoff
#' deparse(CO2, width.cutoff = 500L) # has length 6
#' safe_deparse(CO2)                 # has length 1
#' @export
safe_deparse <- function(expr, ...) 
{
  paste0(deparse(expr, width.cutoff = 500L, ...), collapse = "")
}

#' Strip all attributes from a variable
#'
#' Strips all the attributes from a variable.
#'
#' @param x Input to strip.
#' @return \code{x}, without attributes.
#' @examples
#' x <- structure(c(foo = 1, bar = 2), some_attr = 3)
#' x2 <- strip_attributes(x)
#' attributes(x)
#' attributes(x2)
#' @export
strip_attributes <- function(x)
{
  attributes(x) <- NULL
  x
}
 
#' Only use the first element of a vector
#'
#' If the input is not scalar, then only the first element is returned, 
#' with a warning.
#'
#' @param x Input that should be scalar.
#' @param indexer Either double indexing, \code{"[["} (the default) or
#' single indexing \code{"["}.
#' @param .xname Not intended to be used directly.
#' @return If \code{x} is scalar, it is returned unchanged, otherwise
#' only the first element is returned, with a warning.
#' @examples 
#' dont_stop(use_first(1:5))
#' @export
use_first <- function(x, indexer = c("[[", "["), .xname = get_name_in_parent(x))
{
  len_x <- length(x)
  # Can't use assert_is_non_empty, is_scalar in next lines because those 
  # functions calls this one.
  if(len_x == 0L)
  {
    stop(sprintf("%s has length 0.", .xname))
  }
  if(len_x == 1L)
  {
    return(x)
  }
  indexer <- match.fun(match.arg(indexer))
  x1 <- indexer(x, 1L)
  warning(
    sprintf("Only the first value of %s (= %s) will be used.", .xname, as.character(x1)),
    call. = FALSE
  )
  x1
}

test_that(
  "to_names with a character vector returns unquoted character names",
  {
    x <- c("abc", "", "NA", NA)
    expected <- x
    actual <- to_names(x)
    expect_equal(actual, expected)
  }
)

test_that(
  "to_names with a (double) numeric vector returns 17 sig fig 'g' formatting",
  {
    x <- with(.Machine, c(1 + double.eps, double.xmax, double.xmin, NaN, -Inf, NA))
    expected <- ifelse(is.na(x), NA_real_, sprintf("%.17g", x))
    actual <- to_names(x)
    expect_equal(actual, expected)
  }
)

test_that(
  "to_names with a complex vector returns returns 17 sig fig 'g' formatting for each component",
  {
    x <-  with(.Machine, c(1 + double.eps, double.xmax, double.xmin, NaN, -Inf, NA)) * (1 + 1i)
    expected <- ifelse(is.na(x), NA_complex_, sprintf("%.17g+%.17gi", Re(x), Im(x)))
    actual <- to_names(x)
    expect_equal(actual, expected)
  }
)

test_that(
  "to_names with a list input returns deparsed object",
  {
    x <- list(NA, 1 + .Machine$double.eps, "abc", list(Inf, list("def", NA)))
    expected <- as.character(x)
    actual <- to_names(x)
    expect_equal(actual, expected)
  }
)



test_that("test.coerce_to.numeric_vector_to_data_frame.returns_data_frame", 
  {
    x <- 1:5
    expected <- data.frame(x = x)
    expect_equal(suppressWarnings(coerce_to(x, "data.frame")), expected)
    expect_warning(coerce_to(x, "data.frame"))
  })

test_that(
  "dont_stop with multiple errors and warnings successfully runs",
  {
    expected <- list(
      'stop("If you don\'t stop;")' = simpleError("If you don't stop;"),
      'warning("Someone\'s gonna find yo\' ass dead (this is a warning)")' = simpleWarning("Someone's gonna find yo' ass dead (this is a warning)"),
      'warning("Someone\'s gonna poison your food (this is a warning)")' = simpleWarning("Someone's gonna poison your food (this is a warning)"),
      'stop("Don\'t stop, no no, you\'ll be sorry")' = simpleError("Don\'t stop, no no, you\'ll be sorry"),
      'stop("Don\'t stop, thinking about tomorrow")' = simpleError("Don't stop, thinking about tomorrow"),
      'stop("Don\'t stop, it\'ll soon be here")' = simpleError("Don't stop, it'll soon be here")
    )
    actual <- dont_stop(
      {
        # With apologies to Lil' Kim
        stop("If you don't stop;")
        warning("Someone's gonna find yo' ass dead (this is a warning)")
        warning("Someone's gonna poison your food (this is a warning)")
        stop("Don't stop, no no, you'll be sorry")
        
        # Bonus errors for David, Jenny and other Fleetwood Mac fans
        stop("Don't stop, thinking about tomorrow")
        stop("Don't stop, it'll soon be here")
      }
    )
    expect_identical(actual, expected)
  }
)

test_that(
  "dont_stop works with objects that don't deparse to a single string",
  {
    expected <- list("function() {}" = function() {})
    actual <- dont_stop(
      # deparse returns a character vector 
      function() {} 
    )
    # don't test for identicality due to function environment
    expect_equal(actual, expected, check.environment = FALSE)
  }
)

test_that(
  "get_name_in_parent works when object exists outside of function",
  {
    outside <- 1
    f <- function(inside) 
    {
      get_name_in_parent(inside)
    }
    expected <- "outside"
    actual <- f(outside)
    expect_identical(actual, expected)
  }
)

test_that(
  "get_name_in_parent works when object doesn't exist outside of function",
  {
    f <- function(inside) 
    {
      get_name_in_parent(inside)
    }
    expected <- "1"
    actual <- f(1)
    expect_identical(actual, expected)
  }
)

test_that(
  "get_name_in_parent works with percent inside function call, escape_percent = TRUE",
  {
    f <- function(inside) 
    {
      get_name_in_parent(inside)
    }
    expected <- "1 %%>%% exp"
    actual <- f(1 %>% exp)
    expect_identical(actual, expected)
  }
)

test_that(
  "get_name_in_parent works with percent inside function call, escape_percent = FALSE",
  {
    f <- function(inside) 
    {
      get_name_in_parent(inside, FALSE)
    }
    expected <- "1 %>% exp"
    actual <- f(1 %>% exp)
    expect_identical(actual, expected)
  }
)

test_that(
  "merge_dots_with_list takes duplicates from ...",
  {
    expected <- list(x = 1, y = "b", z = TRUE)
    expect_warning(
      actual <- merge_dots_with_list(x = 1, y = "b", l = list(y = "c", z = TRUE)),
      "Duplicated arguments: y"
    )
    expect_equal(actual, expected)
  }
)

test_that(
  "merge_dots_with_list throws an error with unnamed arguments and allow_unnamed_elements = FALSE",
  {
    expect_error(
      merge_dots_with_list(x = 1, "b", l = list(y = "c")),
      "There are unnamed elements in x or y, but allow_unnamed_elements = FALSE"
    )
  }
)

test_that(
  "merge_dots_with_list works with unnamed arguments and allow_unnamed_elements = TRUE",
  {
    expected <- list(x = 1, y = "c", "b")
    actual <- merge_dots_with_list(
      x = 1, "b", l = list(y = "c"), 
      allow_unnamed_elements = TRUE
    )
    expect_equal(actual, expected)
  }
)

test_that(
  "merge_dots_with_list works with no list argument",
  {
    expected <- list(x = 1, y = "b")
    actual <- merge_dots_with_list(x = 1, y = "b")
    expect_equal(actual, expected)
  }
)

test_that(
  "test.parenthesise.character_input.returns_parenthesised_input",  
  {
    x <- "foo"
    types <- eval(formals(parenthesise)$type)
    actual <- vapply(
      types,
      function(type) parenthesise(x, type),
      character(1),
      USE.NAMES = FALSE
    )
    expected <- c(
      "(foo)", "[foo]", "{foo}", "<foo>", "\u3008foo\u3009", 
      "- foo -", "\u2013 foo \u2013", "\u2014foo\u2014", ", foo, "
    )
    expect_identical(actual, expected)
  }
)

test_that("test.use_first.a_list_double_indexing.returns_contents_of_first_element", 
  {
    x <- as.list(letters)
    expected <- "a"
    expect_identical(expected, suppressWarnings(use_first(x)))
    expect_warning(use_first(x))
  })

test_that("test.use_first.a_list_single_indexing.returns_first_element", {
  x <- as.list(letters)
  expected <- list("a")
  expect_identical(expected, suppressWarnings(use_first(x, "[")))
  expect_warning(use_first(x, "["))
})

test_that("test.use_first.a_scalar.returns_x", {
  x <- "a"
  expected <- x
  expect_identical(expected, use_first(x))
})

test_that("test.use_first.a_vector_double_indexing.returns_first_element", 
  {
    x <- letters
    expected <- "a"
    expect_identical(expected, suppressWarnings(use_first(x)))
    expect_warning(use_first(x))
  })

test_that("test.use_first.a_vector_single_indexing.returns_first_element", 
  {
    x <- letters
    expected <- "a"
    expect_identical(expected, suppressWarnings(use_first(x, "[")))
    expect_warning(use_first(x, "["))
  })

test_that("test.use_first.empty.throws_error", {
  x <- NULL
  expect_error(use_first(x))
}) 

test_that(
  "print_and_capture returns a string of the captured output.",
  {
    expected <- "  x\n1 a\n2 b\n3 c"
    actual <- print_and_capture(data.frame(x = letters[1:3]))
    expect_equal(actual, expected)
  }
)

#' @rdname Truth
#' @export
is_identical_to_false <- function(x, allow_attributes = FALSE, 
  .xname = get_name_in_parent(x))
{
  if(allow_attributes) 
  {
    x <- strip_attributes(x)
  }
  if(!identical(FALSE, x)) 
  {
    msg <- gettextf(
      "%s is not identical to FALSE; its value is %s.", 
      .xname, 
      safe_deparse(x),
      domain = "R-assertive.base"
    )
    return(false(msg))
  }
  TRUE
}                  

#' @rdname Truth
#' @export
is_identical_to_na <- function(x, allow_attributes = FALSE, 
  .xname = get_name_in_parent(x))
{
  if(allow_attributes) 
  {
    x <- strip_attributes(x)
  }
  if(!identical(NA, x) && 
     !identical(NA_real_, x) && 
     !identical(NA_character_, x) && 
     !identical(NA_integer_, x) && 
     !identical(NA_complex_, x))
  {
    msg <- gettextf(
      "%s is not identical to NA; its value is %s.", 
      .xname, 
      safe_deparse(x),
      domain = "R-assertive.base"
    )
    return(false(msg))
  }
  TRUE
}

#' @rdname Truth
#' @export
is_identical_to_true <- function(x, allow_attributes = FALSE, 
  .xname = get_name_in_parent(x))
{
  if(allow_attributes) 
  {
    x <- strip_attributes(x)
  }
  if(!identical(TRUE, x))
  {
    msg <- gettextf(
      "%s is not identical to TRUE; its value is %s.", 
      .xname, 
      safe_deparse(x),
      domain = "R-assertive.base"
    )
    return(false(msg))
  }
  TRUE
}

test_that(
  "test is_identical_to_false with false returns true", 
  {
    expect_true(is_identical_to_false(FALSE))
  }
)

test_that(
  "test is_identical_to_false with a false vector returns false", 
  {
    expect_false(is_identical_to_false(logical(2)))
  }
)

test_that(
  "test is_identical_to_false with NA returns false", 
  {
    expect_false(is_identical_to_false(NA))
  }
)

test_that(
  "test is_identical_to_false with false + attr returns allow_attributes", 
  {
    x <- c(truth = FALSE)
    expect_false(is_identical_to_false(x))
    expect_true(is_identical_to_false(x, allow_attributes = TRUE))
  }
)


test_that(
  "test is_identical_to_na with TRUE returns false", 
  {
    expect_false(is_identical_to_na(TRUE))
  }
)

test_that(
  "test is_identical_to_na with NA returns true", 
  {
    expect_true(is_identical_to_na(NA))
  }
)

test_that(
  "test is_identical_to_na with an NA vector.returns false", 
  {
    expect_false(is_identical_to_na(rep.int(NA, 2)))
  }
)

test_that(
  "test is_identical_to_na NA + attr returns allow_attributes", 
  {
    x <- c(truth = NA)
    expect_false(is_identical_to_na(x))
    expect_true(is_identical_to_na(x, allow_attributes = TRUE))
  }
)


test_that(
  "test is_identical_to_true NA returns false", 
  {
    expect_false(is_identical_to_true(NA))
  }
)

test_that(
  "test is_identical_to_true with true returns true", 
  {
    expect_true(is_identical_to_true(TRUE))
  }
)

test_that(
  "test is_identical_to_true with a true vector returns false", 
  {
    expect_false(is_identical_to_true(rep.int(TRUE, 2)))
  }
)

test_that(
  "test is_identical_to_true true + attr returns allow_attributes", 
  {
    x <- c(truth = TRUE)
    expect_false(is_identical_to_true(x))
    expect_true(is_identical_to_true(x, allow_attributes = TRUE))
  }
)

#' Throws an error if a condition isn't met
#'
#' The workhorse of the package that creates an assertion from a predicate.  
#' If a condition isn't met, then an error is thrown.  This function is exported
#' for use by package developers so that they can create their own assert 
#' functions.  
#'
#' @param predicate Function that returns a logical value (possibly 
#' a vector).
#' @param ... Passed to the \code{predicate} function.
#' @param msg The error message, in the event of failure.
#' @param what Either 'all' or 'any', to reduce vectorised tests to a 
#' single value.
#' @param na_ignore A logical value.  If \code{FALSE}, \code{NA} values
#' cause an error; otherwise they do not.  Like \code{na.rm} in many
#' stats package functions, except that the position of the failing
#' values does not change.
#' @param severity How severe should the consequences of the assertion be?  
#' Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.
#' @return \code{FALSE} with the attribute \code{message}, as provided
#' in the input.
#' @note Missing values are considered as \code{FALSE} for the purposes of
#' whether or not an error is thrown.
#' @examples 
#' # Basic usage is like do.call; pass a predicate and the arguments to it.
#' dont_stop(assert_engine(is_true, c(TRUE, FALSE, NA)))
#' 
#' # Customise the error message
#' dont_stop(
#'   assert_engine(is_true, c(TRUE, FALSE, NA), msg = "Not everything is true")
#' )
#' 
#' # Only fail when no values match the predicate's conditions
#' dont_stop(assert_engine(is_true, logical(3), what = "any"))
#' 
#' # You can use base predicates, but the error message isn't as informative
#' dont_stop(assert_engine(is.matrix, 1:5))
#' 
#' # Reduce the severity of failure
#' assert_engine(is_true, c(TRUE, FALSE, NA), severity = "message")
#' 
#' @export
assert_engine <- function(predicate, ..., msg = "The assertion failed.", what = c("all", "any"), na_ignore = FALSE, severity = c("stop", "warning", "message", "none"))
{
  handler_type <- match.arg(severity)
  dots <- list(...)
  return_value <- if(length(dots) > 0) dots[[1]] else NULL
  if(handler_type == "none") 
  {
    return(invisible(return_value))
  }
  what <- match.fun(match.arg(what))
  predicate_name <- get_name_in_parent(predicate)
  
  ok <- predicate(...)
  if(inherits(ok, "scalar_with_cause"))
  {
    if(!isTRUE(ok))
    {
      if(missing(msg))
      {
        msg <- cause(ok)
      }
      give_feedback(handler_type, msg, predicate_name)
    }
  } else # inherits(ok, "vector_with_cause")
  {
    really_ok <- if(na_ignore)
    {
      # ok can be TRUE or NA; FALSE is bad
      ok | is.na(ok)
    } else
    {
      # ok can be TRUE; FALSE or NA is bad
      ok & !is.na(ok)
    }
    if(!what(really_ok))
    {
      # Append first few failure values and positions to the error message.
      msg <- paste(enc2utf8(msg), print_and_capture(ok), sep = "\n")
      give_feedback(handler_type, msg, predicate_name)
    }
  }
  invisible(return_value)
}

give_feedback <- function(handler_type, msg, predicate_name)
{
  handler <- match.fun(
    handler_type
  )
  ass_condition <- switch(
    handler_type,
    stop = assertionError,
    warning = assertionWarning,
    message = assertionMessage
  )
  # Throw error/warning/message
  caller <- if(sys.nframe() >= 3)
  {
    sys.call(-3)
  } else
  {
    NULL
  }
  
  # UTF-8 characters do not display correctly under Windows for some 
  # LC_CTYPE locale values, but there isn't much assertive can do about that.
  # https://stackoverflow.com/q/32696241/134830
  handler(ass_condition(paste(predicate_name, msg, sep = " : "), caller, predicate_name))
}

#' FALSE, with a cause of failure.
#'
#' Always returns the value \code{FALSE}, with a cause attribute.
#'
#' @param ... Passed to \code{gettextf} to create a cause of failure message.
#' @return \code{FALSE} with the attribute \code{cause}, as provided
#' in the input.
#' @seealso \code{\link{cause}} and \code{\link{na}}.
#' @export
false <- function(...)
{
  msg <- if(nargs() > 0L) sprintf(...) else ""
  x <- FALSE
  cause(x) <- msg[1]
  class(x) <- c("scalar_with_cause", "logical")
  x
}

#' NA, with a cause of failure.
#'
#' Always returns the value (logical) \code{NA}, with a cause attribute.
#'
#' @param ... Passed to \code{gettextf} to create a cause of failure message.
#' @return \code{NA} with the attribute \code{cause}, as provided
#' in the input.
#' @seealso \code{\link{cause}} and \code{\link{false}}.
#' @export
na <- function(...)
{
  msg <- if(nargs() > 0L) sprintf(...) else ""
  x <- NA
  cause(x) <- msg[1]
  class(x) <- c("scalar_with_cause", "logical")
  x
}

#' @rdname are_identical
#' @export
assert_are_identical <- function(x, y, allow_attributes = FALSE, 
  severity = getOption("assertive.severity", "stop"))
{
    assert_engine(
    are_identical,
    x, 
    y = y,
    .xname = get_name_in_parent(x),
    .yname = get_name_in_parent(y),
    severity = severity
  )
}

#' @rdname are_identical
#' @export
assert_all_are_identical_legacy <- function(..., l = list())
{
  # Nasty reimplementation of functionality since assert_engine doesn't work
  # ... inputs right now.
  ok <- are_identical_legacy(..., l = list())
  if(!all(ok))
  {
    handler_type <- match.arg(
      getOption("assertive.severity"), 
      c("stop", "warning", "message", "none")
    )
    if(handler_type == "none") return()
    handler <- match.fun(handler_type)
    handler(
      "The expressions ", 
      toString(as.list(match.call())[-1]), 
      " are not all identical.",
      call. = FALSE
    )
  }
}

#' @rdname are_identical
#' @export
assert_any_are_identical_legacy <- function(..., l = list())
{
  # Also nasty.
  ok <- are_identical_legacy(..., l = list())
  if(!any(ok))
  {
    handler_type <- match.arg(
      getOption("assertive.severity"), 
      c("stop", "warning", "message", "none")
    )
    if(handler_type == "none") return()
    handler <- match.fun(handler_type)
    handler(
      "The expressions ", 
      toString(as.list(match.call())[-1]), 
      " are all not identical.",
      call. = FALSE
    )
  }
}

#' @rdname Truth
#' @export
is_false <- function(x, .xname = get_name_in_parent(x))
{
  x <- coerce_to(x, "logical", .xname)
  call_and_name(
    function(x) 
    {
      is_na_x <- is.na(x)
      ok <- !(x | is_na_x)  # same as !x & !is_na_x
      set_cause(ok, ifelse(is_na_x, "missing", "true"))
    }, 
    x
  )
}

#' @rdname Truth
#' @export
is_na <- function(x, coerce_to_logical = FALSE, .xname = get_name_in_parent(x))
{
  call_and_name(
    function(x)
    {
      if(coerce_to_logical)
      {
        x <- coerce_to(x, "logical", .xname)
      }
      ok <- is.na(x)
      if(is.logical(x))
      {
        set_cause(ok, ifelse(x, "true", "false"))
      } else
      {
        set_cause(ok, "not missing")
      }
    }, 
    x
  )
}

#' @rdname Truth
#' @export
is_not_na <- function(x, coerce_to_logical = FALSE, .xname = get_name_in_parent(x))
{
  call_and_name(
    function(x)
    {
      if(coerce_to_logical)
      {
        x <- coerce_to(x, "logical", .xname)
      }
      ok <- !is.na(x)
      set_cause(ok, "missing")
    }, 
    x
  )
}

#' @rdname Truth
#' @export
is_not_false <- function(x, .xname = get_name_in_parent(x))
{
  x <- coerce_to(x, "logical", get_name_in_parent(x))
  call_and_name(
    function(x)
    {
      ok <- x | is.na(x)
      set_cause(ok, "false")
    }, 
    x
  )
}

#' @rdname Truth
#' @export
is_not_true <- function(x, .xname = get_name_in_parent(x))
{
  x <- coerce_to(x, "logical", .xname)
  call_and_name(
    function(x)
    {
      ok <- !x | is.na(x)
      set_cause(ok, "true")
    }, 
    x
  )
}

#' @rdname Truth
#' @export
is_true <- function(x, .xname = get_name_in_parent(x))
{
  x <- coerce_to(x, "logical", .xname)
  call_and_name(
    function(x) 
    {
      is_na_x <- is.na(x)
      ok <- x & !is_na_x
      set_cause(ok, ifelse(is_na_x, "missing", "false"))   
    }, 
    x
  )
}

test_that(
  "test is_false with a logical input returns true when false",
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(FALSE, TRUE, FALSE)
    actual <- assertive.base::is_false(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("true", "", "missing")))
  }
)

test_that(
  "test is_na with a logical input returns true when NA", 
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(FALSE, FALSE, TRUE)
    actual <- is_na(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("true", "false", "")))
  }
) 

test_that(
  "test is_na with a character input and no coercion returns true when not NA", 
  {
    x <- c("T", "F", "0", "1", "a", "NA", NA)
    expected <- rep.int(c(FALSE, TRUE), c(6, 1))
    actual <- is_na(x, coerce_to_logical = FALSE)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(
      cause(actual), 
      noquote(rep.int(c("not missing", ""), c(6, 1)))
    )
  }
) 

test_that(
  "test is_na with a character input and coercion returns true when not 'T' or 'F'", 
  {
    x <- c("T", "F", "0", "1", "a", "NA", NA)
    expected <- rep.int(c(FALSE, TRUE), c(2, 5))
    expect_warning(
      actual <- is_na(x, coerce_to_logical = TRUE),
      "Coercing x to class .logical.\\."
    )
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(
      cause(actual), 
      noquote(rep.int(c("true", "false", ""), c(1, 1, 5)))
    )
  }
) 

test_that(
  "test is_na with a complex input and no coercion returns true when not NA", 
  {
    x <- c(0, 1, 1i, 1 + 1i, NA)
    expected <- rep.int(c(FALSE, TRUE), c(4, 1))
    actual <- is_na(x, coerce_to_logical = FALSE)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(
      cause(actual), 
      noquote(rep.int(c("not missing", ""), c(4, 1)))
    )
  }
) 

test_that(
  "test is_na with a complex input and coercion returns true when not NA", 
  {
    x <- c(0, 1, 1i, 1 + 1i, NA)
    expected <- rep.int(c(FALSE, TRUE), c(4, 1))
    expect_warning(
      actual <- is_na(x, coerce_to_logical = TRUE),
      "Coercing x to class .logical.\\."
    )
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(
      cause(actual), 
      noquote(rep.int(c("false", "true", ""), c(1, 3, 1)))
    )
  }
) 

test_that(
  "test is_na with a list input and no coercion returns true when elements contain a single NA", 
  {
    x <- list(NA, TRUE, FALSE, c(TRUE, FALSE, NA))
    expected <- rep.int(c(TRUE, FALSE), c(1, 3))
    actual <- is_na(x, coerce_to_logical = FALSE)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(
      cause(actual), 
      noquote(rep.int(c("", "not missing"), c(1, 3)))
    )
  }
) 

test_that(
  "test is_na with a list input and coercion throw an error", 
  {
    x <- list(NA, TRUE, FALSE, c(TRUE, FALSE, NA))
    expect_error(
      is_na(x, coerce_to_logical = TRUE),
      "x cannot be coerced to any of these types: .logical.\\."
    )
  }
) 

test_that(
  "test is_not_false with a logical input returns true when not false", 
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(TRUE, FALSE, TRUE)
    actual <- is_not_false(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("", "false", "")))
  }
)

test_that(
  "test is_not_na with a logical input returns true when not NA", 
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(TRUE, TRUE, FALSE)
    actual <- is_not_na(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("", "", "missing")))
  }
) 

test_that(
  "test is_not_true with a logical input returns true when not true", 
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(FALSE, TRUE, TRUE)
    actual <- is_not_true(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("true", "", "")))
  }
) 

test_that(
  "test is_true with a logical input returns true when true", 
  {
    x <- c(TRUE, FALSE, NA)
    expected <- c(TRUE, FALSE, FALSE)
    actual <- assertive.base::is_true(x)
    expect_equal(strip_attributes(actual), expected)
    expect_named(actual)
    expect_equal(cause(actual), noquote(c("", "false", "missing")))
  }
) 

#' Alternative version of is
#' 
#' If a function named \code{is.class} exists, call \code{is.class(x)}.
#' If not, call \code{is(x, class)}.
#' @param x Input to check.
#' @param class Target class that \code{x} maybe belong to.
#' @param .xname Not intended to be used directly.
#' @return \code{TRUE} if x belongs to the class and \code{FALSE} 
#' otherwise. 
#' @seealso \code{\link[methods]{is}}, and 
#' \code{\link[assertive.types]{assert_is_all_of}} for the corresponding assert fns.
#' @examples
#' is2(1:5, "character")
#' is2(matrix(1:5), "character")
#' is2(1:5, c("character", "list", "numeric"))
#' is2(mean, c("function", "data.frame"))
#' @importFrom methods is
#' @export
is2 <- function(x, class, .xname = get_name_in_parent(x))
{    
  # Can't use is_empty in next line because that function calls this one.
  if(length(class) == 0L) stop("You must provide a class.")
  if(length(class) > 1L) 
  {
    return(
      set_cause(
        bapply(class, function(cl) is2(x, cl, "")),
        sprintf("%s is not '%s'", type_description(x), class)
      )
    )
  }
  ok <- tryCatch(
    {
      is.class <- match.fun(paste0("is.", class))
      is.class(x)
    },
    error = function(e)
    {
      is(x, class) 
    }
  )
  if(!ok)
  {
    return(
      false(
        "%s is not of class '%s'; it has %s.", 
        .xname, 
        class, 
        type_description(x)
      )
    )
  }
  TRUE
}

#' Coerce variable to a different class
#'
#' Coerce the input to a different class, with a warning.  More reliable then 
#' \code{\link[methods]{as}}, and supports coercion to multiple classes.
#'
#' @param x Input to coerce.
#' @param target_class The desired class of x.  Multiple values allowed (see 
#' note).
#' @param .xname Not intended to be used directly.
#' @return The input \code{x} after attempted coercion to the target class.
#' @note If x does not already have the target class, a warning is given
#' before coercion.  
#' The function will try and convert the \code{x} to each of the classes given
#' in \code{target_class}, in order, until it succeeds or runs out of classes
#' to try.  It will first try and convert \code{x} using a dedicated 
#' \code{as.target_class} function if that exists.  If it does not exist, or 
#' throws an error then \code{coerce_to} will try to use 
#' \code{as(x, target_class)}.
#' @seealso \code{\link[methods]{is}} and \code{\link[methods]{as}}.
#' @examples
#' # Numbers can be coerced to characters but not to calls.
#' dont_stop(coerce_to(1:5, c("call", "character")))
#' @importFrom methods as
#' @export
coerce_to <- function(x, target_class, .xname = get_name_in_parent(x))
{
  # Can't use is_empty in next line because that function calls this one.
  if(length(target_class) == 0L) 
  {
    stop("You must provide a class.")
  }
  if(!is.character(target_class))
  {
    stop("target_class should be a character vector.")
  }
  for(this_class in target_class)
  {
    if(!is2(x, this_class))
    {
      warning(
        sprintf(
          "Coercing %s to class %s.", 
          .xname,
          sQuote(this_class)
        ),
        call. = FALSE
      )
    }
    tryCatch(
      {
        as.this_class <- match.fun(paste0("as.", this_class))
        return(as.this_class(x))
      },
      error = function(e)
      {
        # as.this_class doesn't exist; try as(, "this_class") instead
        tryCatch(
          return(as(x, this_class)),
          error = function(e)
          {
            # Can't coerce to this class; warn and move to next class
            warning(
              sprintf(
                "%s cannot be coerced to type %s.", 
                .xname,
                sQuote(this_class)
              ), 
              call. = FALSE
            )
          }
        )
      }
    )
  }
  # Nothing worked; throw an error
  stop(
    sprintf(
      "%s cannot be coerced to any of these types: %s.", 
      .xname,
      toString(sQuote(target_class))
    )
  )
}

#' Describe the type of object
#' 
#' Get the class or mode (for arrays).
#' @param x A variable.
#' @return A string.
#' @noRd
type_description <- function(x)
{
  if(is.array(x))
  {
    sprintf(sprintf("class '%s %s'", class(x[FALSE]), toString(class(x))))
  } else if(is.function(x))
  {
    sprintf(sprintf("class '%s %s'", typeof(x), toString(class(x))))
  } else if(isS4(x))
  {
    sprintf(sprintf("S4 class '%s'", toString(class(x))))
  }  else
  {
    sprintf("class '%s'", toString(class(x)))
  }
}

merge.NULL <- function(x, y, ...)
{
  return(y)
}

names_never_null <- function(x)
{
  nms <- names(x)
  if(is.null(nms))
  {
    nms <- character(length(x))
  }  
  nms
}

#' Truncate a string
#' 
#' Truncates a character vector to have a maximum length.
#' @param x A character vector, or something coercible to one.
#' @param width A positive integer.
#' @return A character vector
#' @seealso \code{\link[base]{abbreviate}}
#' @examples
#' assertive.base:::truncate(c("abcd", "efghi", "jklmno", "pqrstuv"), 5)
#' @noRd
truncate <- function(x, width = getOption("width"))
{
  x <- as.character(x)
  ifelse(
    nchar(x) > width,
    # paste0(substring(x, 1, width - 1), "\u2026") would be better, but some
    # setups don't display unicode properly.
    paste0(substring(x, 1, width - 3), "..."),
    x
  )
} 

#' Is the input TRUE/FALSE/NA?
#' 
#' Checks to see if the input is \code{TRUE},  \code{FALSE} or  \code{NA}.
#'
#' @param x Input to check.  See note.
#' @param allow_attributes If \code{TRUE}, a scalar value of \code{TRUE}
#' with attributes is allowed.
#' @param coerce_to_logical Logical: should the input be coerced to logical
#' before checking?  See note.
#' @param .xname Not intended to be used directly.
#' @param severity How severe should the consequences of the assertion be?  
#' Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.
#' @note \code{is_identical_to_true} wraps the base function \code{isTRUE}, 
#' providing more information on failure.  Likewise, 
#' \code{is_identical_to_false} checks that the input is identical to FALSE.  If
#' \code{allow_attributes} is \code{TRUE}, a scalar value of \code{TRUE} with 
#' attributes is allowed. \code{is_true} and \code{is_false} are vectorized, 
#' returning \code{TRUE} when the inputs are \code{TRUE} and \code{FALSE} 
#' respectively.
#' 
#' The for \code{is_true}, \code{is_false}, \code{is_not_true} and 
#' \code{is_not_false}, \code{x} argument will be coerced to be a logical vector 
#' if it isn't already.  
#' 
#' Coercion to logical is optional for \code{is_na} and \code{is_not_na}. If 
#' you do coerce, it means that \code{is_na} differs in behaviour from 
#' \code{base::is.na} for character vector, list and data frame inputs.  To 
#' replicate the behaviour of \code{is.na}, ensure the argument 
#' \code{coerce_to_logical} is \code{FALSE} (this is the default).
#' 
#' Note that in assertive version 0.1-4 and prior, 
#' \code{is_identical_to_true/false} were named \code{is_true/false} and the 
#' vectorized versions were not present.
#' @return The \code{is*} functions return \code{TRUE} if the input is 
#' \code{TRUE}/\code{FALSE}. The \code{assert_*} functions return nothing but 
#' throw an error if the corresponding \code{is_*} function returns 
#' \code{FALSE}.
#' @seealso \code{\link[base]{isTRUE}}.
#' @examples
#' # Checks against logical values using base::identical
#' assert_is_identical_to_true(TRUE)
#' assert_is_identical_to_false(FALSE)
#' assert_is_identical_to_na(NA)
#' 
#' # Other NA types match
#' assert_is_identical_to_na(NA_complex_)
#' 
#' # NaN is not NA
#' dont_stop(assert_is_identical_to_na(NaN))
#' 
#' # For a slightly less strict test, you can ignore attributes
#' assert_is_identical_to_true(c(truth = TRUE), allow_attributes = TRUE)
#' assert_is_identical_to_false(matrix(FALSE), allow_attributes = TRUE)
#' assert_is_identical_to_na(structure(NA, class = "nanana"), allow_attributes = TRUE)
#' 
#' # Vectorized predicates (package name explicitly given to prevent
#' # problems with testthat name clash)
#' x <- c(TRUE, FALSE, NA)
#' assertive.base::is_true(x)
#' assertive.base::is_false(x)
#' is_na(x)
#' 
#' # ...and their opposites
#' is_not_true(x)
#' is_not_false(x)
#' is_not_na(x)
#' 
#' # Check that at least one element fits the condition
#' assert_any_are_true(x)
#' assert_any_are_false(x)
#' assert_any_are_na(x)
#' 
#' # These checks should fail:
#' dont_stop({
#'   assert_is_identical_to_true(c(truth = TRUE))
#'   assert_is_identical_to_true(1)
#'   assert_is_identical_to_true(c(TRUE, TRUE))
#'   assert_is_identical_to_false(matrix(FALSE))
#'   assert_is_identical_to_na(structure(NA, class = "nanana"))
#'   assert_all_are_true(x)
#'   assert_all_are_false(x)
#'   assert_all_are_na(x)
#' })
#' 
#' # base::is.na has non-standard behaviour for data.frames and lists.
#' # is_na and is_not_na coerce to logical vectors (except character input).
#' # unlist the input or use an apply function.
#' d <- data.frame(
#'   x = c(TRUE, FALSE, NA), 
#'   y = c(0, NA, 2), 
#'   z = c("a", "NA", NA)
#' )
#' is.na(d)
#' is_na(unlist(d))
#' @name Truth
NULL

#' @rdname Truth
#' @export
assert_is_identical_to_false <- function(x, allow_attributes = FALSE, 
  severity = getOption("assertive.severity", "stop"))
{                                                  
  assert_engine(
    is_identical_to_false,
    x, 
    allow_attributes = allow_attributes, 
    .xname = get_name_in_parent(x),
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_is_identical_to_na <- function(x, allow_attributes = FALSE, 
  severity = getOption("assertive.severity", "stop"))
{                                                  
  assert_engine(
    is_identical_to_na,
    x,
    allow_attributes = allow_attributes, 
    .xname = get_name_in_parent(x),
    severity = severity
  )
}

#' @rdname Truth
#' @export
assert_is_identical_to_true <- function(x, allow_attributes = FALSE, 
  severity = getOption("assertive.severity", "stop"))
{                                                  
  assert_engine(
    is_identical_to_true,
    x,
    allow_attributes = allow_attributes, 
    .xname = get_name_in_parent(x),
    severity = severity
  )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{print_and_capture}
\alias{print_and_capture}
\title{Print a variable and capture the output}
\usage{
print_and_capture(x, ...)
}
\arguments{
\item{x}{A variable.}

\item{...}{Arguments passed to \code{\link[base]{print}} methods.}
}
\value{
A string.
}
\description{
Prints a variable and captures the output, collapsing the value to a single 
string.
}
\examples{
# This is useful for including data frames in warnings or errors
message("This is the sleep dataset:\n", print_and_capture(sleep))
}
\seealso{
\code{\link[base]{print}}, \code{\link[utils]{capture.output}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{safe_deparse}
\alias{safe_deparse}
\title{Safe version of deparse}
\usage{
safe_deparse(expr, ...)
}
\arguments{
\item{expr}{Any R expression.}

\item{...}{Passed to \code{\link[base]{deparse}}.}
}
\value{
A character vector or length one.
}
\description{
A version of \code{\link[base]{deparse}} that is guaranteed to always return 
a single string.
}
\note{
By default the RStudio IDE truncates output in the console at 1000 
characters.  Consequently, if you use \code{safe_deparse} on large or complex
objects, you won't see the full value. You can change the setting using
Tools -> "Global Options..." -> Code -> Display -> Console -> "Limit length
of lines displayed in console to:".
}
\examples{
# safe_deparse only differs from deparse when the deparse string is longer
# than width.cutoff
deparse(CO2, width.cutoff = 500L) # has length 6
safe_deparse(CO2)                 # has length 1
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{use_first}
\alias{use_first}
\title{Only use the first element of a vector}
\usage{
use_first(x, indexer = c("[[", "["), .xname = get_name_in_parent(x))
}
\arguments{
\item{x}{Input that should be scalar.}

\item{indexer}{Either double indexing, \code{"[["} (the default) or
single indexing \code{"["}.}

\item{.xname}{Not intended to be used directly.}
}
\value{
If \code{x} is scalar, it is returned unchanged, otherwise
only the first element is returned, with a warning.
}
\description{
If the input is not scalar, then only the first element is returned, 
with a warning.
}
\examples{
dont_stop(use_first(1:5))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cause.R
\name{print.scalar_with_cause}
\alias{print.scalar_with_cause}
\alias{print.vector_with_cause}
\title{Print methods for objects with a cause attribute}
\usage{
\method{print}{scalar_with_cause}(x, ...)

\method{print}{vector_with_cause}(x, na_ignore = FALSE, n_to_show = 10, ...)
}
\arguments{
\item{x}{an object of class \code{scalar_with_cause} or
\code{vector_with_cause}.}

\item{...}{Currently unused.}

\item{na_ignore}{A logical value.  If \code{FALSE}, \code{NA} values
are printed; otherwise they do not.  Like \code{na.rm} in many
stats package functions, except that the position of the failing
values does not change.}

\item{n_to_show}{A natural number.  The maximum number of failures 
to show.}
}
\description{
Prints objects of class \code{scalar_with_cause} and 
\code{vector_with_cause}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{merge_dots_with_list}
\alias{merge_dots_with_list}
\title{Merge ellipsis args with a list.}
\usage{
merge_dots_with_list(
  ...,
  l = list(),
  warn_on_dupes = TRUE,
  allow_unnamed_elements = FALSE
)
}
\arguments{
\item{...}{Some inputs.}

\item{l}{A list.}

\item{warn_on_dupes}{\code{TRUE} or \code{FALSE}.  Should a warning be given 
if both \code{x} and \code{y} have elements with the same name.  See note.}

\item{allow_unnamed_elements}{\code{TRUE} or \code{FALSE}. Should unnamed
elements be allowed?}
}
\value{
A list containing the merged inputs.
}
\description{
Merges variable length ellipsis arguments to a function with a list argument.
}
\note{
If any arguments are present in both the \code{...} and \code{l} 
arguments, the \code{...} version takes preference, and a warning is thrown.
}
\examples{
merge_dots_with_list(
  foo = 1, 
  bar = 2, 
  baz = 3, 
  l = list(foo = 4, baz = 5, quux = 6)
)
}
\seealso{
\code{\link{merge.list}}, \code{\link[base]{merge}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{bapply}
\alias{bapply}
\title{Wrapper to vapply that returns booleans}
\usage{
bapply(x, predicate, ...)
}
\arguments{
\item{x}{A vector (atomic or list).}

\item{predicate}{A predicate (function that returns a bool) to apply.
elementwise to \code{x}.}

\item{...}{Passed to \code{vapply}.}
}
\value{
A logical vector.
}
\description{
Wrapper to \code{\link{vapply}} for functions that return a boolean (logical 
scalar) value.
}
\note{
\code{USE.NAMES} is set to \code{TRUE}
}
\seealso{
\code{\link{vapply}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/engine.R
\name{na}
\alias{na}
\title{NA, with a cause of failure.}
\usage{
na(...)
}
\arguments{
\item{...}{Passed to \code{gettextf} to create a cause of failure message.}
}
\value{
\code{NA} with the attribute \code{cause}, as provided
in the input.
}
\description{
Always returns the value (logical) \code{NA}, with a cause attribute.
}
\seealso{
\code{\link{cause}} and \code{\link{false}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/engine.R
\name{assert_engine}
\alias{assert_engine}
\title{Throws an error if a condition isn't met}
\usage{
assert_engine(
  predicate,
  ...,
  msg = "The assertion failed.",
  what = c("all", "any"),
  na_ignore = FALSE,
  severity = c("stop", "warning", "message", "none")
)
}
\arguments{
\item{predicate}{Function that returns a logical value (possibly 
a vector).}

\item{...}{Passed to the \code{predicate} function.}

\item{msg}{The error message, in the event of failure.}

\item{what}{Either 'all' or 'any', to reduce vectorised tests to a 
single value.}

\item{na_ignore}{A logical value.  If \code{FALSE}, \code{NA} values
cause an error; otherwise they do not.  Like \code{na.rm} in many
stats package functions, except that the position of the failing
values does not change.}

\item{severity}{How severe should the consequences of the assertion be?
Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.}
}
\value{
\code{FALSE} with the attribute \code{message}, as provided
in the input.
}
\description{
The workhorse of the package that creates an assertion from a predicate.  
If a condition isn't met, then an error is thrown.  This function is exported
for use by package developers so that they can create their own assert 
functions.
}
\note{
Missing values are considered as \code{FALSE} for the purposes of
whether or not an error is thrown.
}
\examples{
# Basic usage is like do.call; pass a predicate and the arguments to it.
dont_stop(assert_engine(is_true, c(TRUE, FALSE, NA)))

# Customise the error message
dont_stop(
  assert_engine(is_true, c(TRUE, FALSE, NA), msg = "Not everything is true")
)

# Only fail when no values match the predicate's conditions
dont_stop(assert_engine(is_true, logical(3), what = "any"))

# You can use base predicates, but the error message isn't as informative
dont_stop(assert_engine(is.matrix, 1:5))

# Reduce the severity of failure
assert_engine(is_true, c(TRUE, FALSE, NA), severity = "message")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coercion.R
\name{is2}
\alias{is2}
\title{Alternative version of is}
\usage{
is2(x, class, .xname = get_name_in_parent(x))
}
\arguments{
\item{x}{Input to check.}

\item{class}{Target class that \code{x} maybe belong to.}

\item{.xname}{Not intended to be used directly.}
}
\value{
\code{TRUE} if x belongs to the class and \code{FALSE} 
otherwise.
}
\description{
If a function named \code{is.class} exists, call \code{is.class(x)}.
If not, call \code{is(x, class)}.
}
\examples{
is2(1:5, "character")
is2(matrix(1:5), "character")
is2(1:5, c("character", "list", "numeric"))
is2(mean, c("function", "data.frame"))
}
\seealso{
\code{\link[methods]{is}}, and 
\code{\link[assertive.types]{assert_is_all_of}} for the corresponding assert fns.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/are-identical.R, R/assert-are-identical.R
\name{are_identical}
\alias{are_identical}
\alias{are_identical_legacy}
\alias{assert_are_identical}
\alias{assert_all_are_identical_legacy}
\alias{assert_any_are_identical_legacy}
\title{Are the inputs identical?}
\usage{
are_identical(
  x,
  y,
  allow_attributes = FALSE,
  .xname = get_name_in_parent(x),
  .yname = get_name_in_parent(y)
)

are_identical_legacy(..., l = list())

assert_are_identical(
  x,
  y,
  allow_attributes = FALSE,
  severity = getOption("assertive.severity", "stop")
)

assert_all_are_identical_legacy(..., l = list())

assert_any_are_identical_legacy(..., l = list())
}
\arguments{
\item{x}{An R object or expression.}

\item{y}{Another R object or expression.}

\item{allow_attributes}{If \code{TRUE}, The attributes of \code{x} and 
\code{y} are allowed to differ.}

\item{.xname}{Not intended to be used directly.}

\item{.yname}{Not intended to be used directly.}

\item{...}{Some R expressions, deprecated.}

\item{l}{A list of R expressions, deprecated.}

\item{severity}{How severe should the consequences of the assertion be?
Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.}
}
\value{
\code{are_identical} returns \code{TRUE} if \code{x} and \code{y} 
are identical.  The \code{assert_*} function throws an error on failure.

The legacy function \code{are_identical_legacy} allows an arbitrary number
of inputs and returns a symmetric square logical matrix which is \code{TRUE} 
where pairs of inputs are identical.  (The new version of the function 
is easier to work with, and it is recommended that you switch your code to 
it.)
}
\description{
Checks if the inputs are identical.
}
\examples{
x <- 1:5
are_identical(c(1, -1), cos(c(0, pi)))
assertive.base::dont_stop(assert_are_identical(c(1, 1), cos(c(0, pi))))
}
\seealso{
\code{\link[base]{identical}}, 
\code{\link[assertive.properties]{are_same_length}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{dont_stop}
\alias{dont_stop}
\title{Run code without stopping}
\usage{
dont_stop(expr)
}
\arguments{
\item{expr}{Code to execute.}
}
\value{
A list containing the results of evaluating each call in \code{expr}.
}
\description{
Runs code without stopping for warnings or errors.
}
\note{
This function is dangerous, since it overrides warnings and errors.
Its intended use is for documenting examples of warnings and errors.
}
\examples{
dont_stop({
  warning("a warning")
  x <- 1
  stop("an error")
  y <- sqrt(exp(x + 1))
  assert_is_identical_to_true(y)
  y > 0
})
}
\seealso{
\code{\link[base]{warning}} and \code{\link[base]{stop}} for 
generating warnings and errors respectively; \code{\link[base]{try}} and
\code{\link[base]{conditions}} for handling them.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{call_and_name}
\alias{call_and_name}
\title{Call a function, and give the result names.}
\usage{
call_and_name(fn, x, ...)
}
\arguments{
\item{fn}{A function to call.  See note below.}

\item{x}{The first input to \code{fn}.}

\item{...}{Optional additional inputs to \code{fn}.}
}
\value{
The result of \code{fn(x, ...)}, with names given by the
argument \code{x}.
}
\description{
Calls a function, and names the result with the first argument.
}
\note{
The function, \code{fn}, should return an object with the 
same length as the input \code{x}.  For speed and simplicity, this
isn't checked; it is up to the developer of the assertion to make
sure that this condition holds.
}
\examples{
call_and_name(is.finite, c(1, Inf, NA))

# Make sure that the output is the same size as the input.
# Don't do this:
dont_stop(call_and_name(isTRUE, list(TRUE, FALSE, NA)))
# Do this instead:
call_and_name(
  Vectorize(isTRUE, SIMPLIFY = FALSE),
  list(TRUE, FALSE, NA)
)
}
\seealso{
\code{\link{cause}} and \code{\link{na}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{merge.list}
\alias{merge.list}
\title{Merge two lists}
\usage{
\method{merge}{list}(x, y, warn_on_dupes = TRUE, allow_unnamed_elements = FALSE, ...)
}
\arguments{
\item{x}{A list.}

\item{y}{A list.}

\item{warn_on_dupes}{\code{TRUE} or \code{FALSE}.  Should a warning be given 
if both \code{x} and \code{y} have elements with the same name.  See note.}

\item{allow_unnamed_elements}{\code{TRUE} or \code{FALSE}. Should unnamed
elements be allowed?}

\item{...}{Ignored.}
}
\value{
A list, combining elements from \code{x} and \code{y}.
}
\description{
Merges two lists, taking duplicated elements from the first list.
}
\note{
In the event of elements that are duplicated between \code{x} and 
\code{y}, the versions from \code{x} are used.
}
\examples{
merge(
  list(foo = 1, bar = 2, baz = 3), 
  list(foo = 4, baz = 5, quux = 6)
)

# If unnamed elements are allowed, they are included at the end
merge(
  list("a", foo = 1, "b", bar = 2, baz = 3, "c"), 
  list(foo = 4, "a", baz = 5, "b", quux = 6, "d"),
  allow_unnamed_elements = TRUE
)
}
\seealso{
\code{\link{merge_dots_with_list}}, \code{\link[base]{merge}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{parenthesize}
\alias{parenthesize}
\alias{parenthesise}
\title{Wrap a string in brackets}
\usage{
parenthesize(
  x,
  type = c("round_brackets", "square_brackets", "curly_brackets", "angle_brackets",
    "chevrons", "hyphens", "en_dashes", "em_dashes", "commas")
)

parenthesise(
  x,
  type = c("round_brackets", "square_brackets", "curly_brackets", "angle_brackets",
    "chevrons", "hyphens", "en_dashes", "em_dashes", "commas")
)
}
\arguments{
\item{x}{Character vector to wrap in parenthenses.}

\item{type}{String naming the type of parenthesis.}
}
\value{
A character vector of the input wrapped in parentheses.
}
\description{
Parenthesise a character vector by wrapping elements in brackets, 
dashes or commas.
}
\note{
English grammar terminology is awfully confusing.  The verb 'to 
parenthesise' means to wrap a phrase in brackets or dashes or commas,
thus denoting it as supplementary material that could be left out.
A 'parenthesis' as a noun is often used as a synonym for a round bracket.
}
\examples{
paste("There were three", parenthesise(3), "mice in the experiment.")
paste(
  "I love parmos", 
  parenthesise("Teesside's finest culinary invention", "en_dashes"), 
  "but they are sure to give me heart disease."
)
parenthesise(letters[1:5], "curly")
paste0(
  "The R language", 
  parenthesise("an offshoot of S and Scheme", "commas"), 
  "is quite good for data analysis."
)
}
\seealso{
\code{\link[base]{sQuote}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cause.R
\name{set_cause}
\alias{set_cause}
\title{Set a cause and return the input}
\usage{
set_cause(x, false_value, missing_value = "missing")
}
\arguments{
\item{x}{A variable.}

\item{false_value}{A character vector to set the cause to, where \code{x} is
\code{FALSE}.}

\item{missing_value}{A character vector to set the cause to, where \code{x} is
\code{NA}.}
}
\value{
\code{x}, with a new cause attribute.
}
\description{
Sets the cause attribute of an object and returns that object.
}
\details{
If \code{x} is \code{TRUE} everywhere, this returns the input 
without setting a cause.  Otherwise, the cause is an empty string where 
\code{x} is \code{TRUE}, \code{false_value} where it is \code{FALSE}, and
\code{missing_value} where it is \code{NA}.
}
\seealso{
\code{\link{cause}}, \code{\link[stats]{setNames}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/assert-identical-to-true-false-na.R,
%   R/assert-is-true-false-na.R, R/is-identical-to-true-false-na.R,
%   R/is-true-false-na.R
\name{Truth}
\alias{Truth}
\alias{assert_is_identical_to_false}
\alias{assert_is_identical_to_na}
\alias{assert_is_identical_to_true}
\alias{assert_all_are_false}
\alias{assert_any_are_false}
\alias{assert_all_are_na}
\alias{assert_any_are_na}
\alias{assert_all_are_true}
\alias{assert_any_are_true}
\alias{assert_all_are_not_false}
\alias{assert_any_are_not_false}
\alias{assert_all_are_not_na}
\alias{assert_any_are_not_na}
\alias{assert_all_are_not_true}
\alias{assert_any_are_not_true}
\alias{is_identical_to_false}
\alias{is_identical_to_na}
\alias{is_identical_to_true}
\alias{is_false}
\alias{is_na}
\alias{is_not_na}
\alias{is_not_false}
\alias{is_not_true}
\alias{is_true}
\title{Is the input TRUE/FALSE/NA?}
\usage{
assert_is_identical_to_false(
  x,
  allow_attributes = FALSE,
  severity = getOption("assertive.severity", "stop")
)

assert_is_identical_to_na(
  x,
  allow_attributes = FALSE,
  severity = getOption("assertive.severity", "stop")
)

assert_is_identical_to_true(
  x,
  allow_attributes = FALSE,
  severity = getOption("assertive.severity", "stop")
)

assert_all_are_false(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_false(x, severity = getOption("assertive.severity", "stop"))

assert_all_are_na(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_na(x, severity = getOption("assertive.severity", "stop"))

assert_all_are_true(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_true(x, severity = getOption("assertive.severity", "stop"))

assert_all_are_not_false(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_not_false(x, severity = getOption("assertive.severity", "stop"))

assert_all_are_not_na(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_not_na(x, severity = getOption("assertive.severity", "stop"))

assert_all_are_not_true(x, severity = getOption("assertive.severity", "stop"))

assert_any_are_not_true(x, severity = getOption("assertive.severity", "stop"))

is_identical_to_false(
  x,
  allow_attributes = FALSE,
  .xname = get_name_in_parent(x)
)

is_identical_to_na(x, allow_attributes = FALSE, .xname = get_name_in_parent(x))

is_identical_to_true(
  x,
  allow_attributes = FALSE,
  .xname = get_name_in_parent(x)
)

is_false(x, .xname = get_name_in_parent(x))

is_na(x, coerce_to_logical = FALSE, .xname = get_name_in_parent(x))

is_not_na(x, coerce_to_logical = FALSE, .xname = get_name_in_parent(x))

is_not_false(x, .xname = get_name_in_parent(x))

is_not_true(x, .xname = get_name_in_parent(x))

is_true(x, .xname = get_name_in_parent(x))
}
\arguments{
\item{x}{Input to check.  See note.}

\item{allow_attributes}{If \code{TRUE}, a scalar value of \code{TRUE}
with attributes is allowed.}

\item{severity}{How severe should the consequences of the assertion be?
Either \code{"stop"}, \code{"warning"}, \code{"message"}, or \code{"none"}.}

\item{.xname}{Not intended to be used directly.}

\item{coerce_to_logical}{Logical: should the input be coerced to logical
before checking?  See note.}
}
\value{
The \code{is*} functions return \code{TRUE} if the input is 
\code{TRUE}/\code{FALSE}. The \code{assert_*} functions return nothing but 
throw an error if the corresponding \code{is_*} function returns 
\code{FALSE}.
}
\description{
Checks to see if the input is \code{TRUE},  \code{FALSE} or  \code{NA}.
}
\note{
\code{is_identical_to_true} wraps the base function \code{isTRUE}, 
providing more information on failure.  Likewise, 
\code{is_identical_to_false} checks that the input is identical to FALSE.  If
\code{allow_attributes} is \code{TRUE}, a scalar value of \code{TRUE} with 
attributes is allowed. \code{is_true} and \code{is_false} are vectorized, 
returning \code{TRUE} when the inputs are \code{TRUE} and \code{FALSE} 
respectively.

The for \code{is_true}, \code{is_false}, \code{is_not_true} and 
\code{is_not_false}, \code{x} argument will be coerced to be a logical vector 
if it isn't already.  

Coercion to logical is optional for \code{is_na} and \code{is_not_na}. If 
you do coerce, it means that \code{is_na} differs in behaviour from 
\code{base::is.na} for character vector, list and data frame inputs.  To 
replicate the behaviour of \code{is.na}, ensure the argument 
\code{coerce_to_logical} is \code{FALSE} (this is the default).

Note that in assertive version 0.1-4 and prior, 
\code{is_identical_to_true/false} were named \code{is_true/false} and the 
vectorized versions were not present.
}
\examples{
# Checks against logical values using base::identical
assert_is_identical_to_true(TRUE)
assert_is_identical_to_false(FALSE)
assert_is_identical_to_na(NA)

# Other NA types match
assert_is_identical_to_na(NA_complex_)

# NaN is not NA
dont_stop(assert_is_identical_to_na(NaN))

# For a slightly less strict test, you can ignore attributes
assert_is_identical_to_true(c(truth = TRUE), allow_attributes = TRUE)
assert_is_identical_to_false(matrix(FALSE), allow_attributes = TRUE)
assert_is_identical_to_na(structure(NA, class = "nanana"), allow_attributes = TRUE)

# Vectorized predicates (package name explicitly given to prevent
# problems with testthat name clash)
x <- c(TRUE, FALSE, NA)
assertive.base::is_true(x)
assertive.base::is_false(x)
is_na(x)

# ...and their opposites
is_not_true(x)
is_not_false(x)
is_not_na(x)

# Check that at least one element fits the condition
assert_any_are_true(x)
assert_any_are_false(x)
assert_any_are_na(x)

# These checks should fail:
dont_stop({
  assert_is_identical_to_true(c(truth = TRUE))
  assert_is_identical_to_true(1)
  assert_is_identical_to_true(c(TRUE, TRUE))
  assert_is_identical_to_false(matrix(FALSE))
  assert_is_identical_to_na(structure(NA, class = "nanana"))
  assert_all_are_true(x)
  assert_all_are_false(x)
  assert_all_are_na(x)
})

# base::is.na has non-standard behaviour for data.frames and lists.
# is_na and is_not_na coerce to logical vectors (except character input).
# unlist the input or use an apply function.
d <- data.frame(
  x = c(TRUE, FALSE, NA), 
  y = c(0, NA, 2), 
  z = c("a", "NA", NA)
)
is.na(d)
is_na(unlist(d))
}
\seealso{
\code{\link[base]{isTRUE}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/engine.R
\name{false}
\alias{false}
\title{FALSE, with a cause of failure.}
\usage{
false(...)
}
\arguments{
\item{...}{Passed to \code{gettextf} to create a cause of failure message.}
}
\value{
\code{FALSE} with the attribute \code{cause}, as provided
in the input.
}
\description{
Always returns the value \code{FALSE}, with a cause attribute.
}
\seealso{
\code{\link{cause}} and \code{\link{na}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/conditions.R
\name{assertionError}
\alias{assertionError}
\alias{assertionWarning}
\alias{assertionMessage}
\title{Condition classes}
\usage{
assertionError(message, call = NULL, predicate_name = NULL)

assertionWarning(message, call = NULL, predicate_name = NULL)

assertionMessage(message, call = NULL, predicate_name = NULL)
}
\arguments{
\item{message}{A string describing the problem.}

\item{call}{A call describing the source of the condition.}

\item{predicate_name}{A string naming the predicate that was called when the 
condition occured.}
}
\value{
An object of class \code{assertionError}, \code{assertionWarning}, or
\code{assertionMessage}.
}
\description{
Error, warning, and message classes derived from their simple equivalents.
}
\note{
These objects behave the same as the standard-issue \code{simpleError},
\code{simpleWarning}, and \code{simpleMessage} objects from base-R.  The
extra class allows you to provide custom handling for assertions inside 
\code{tryCatch}.
}
\examples{
tryCatch(
  assert_all_are_true(FALSE), 
  error = function(e) 
  {
    if(inherits(e, "assertionCondition"))
    {
      # Handle assertions
      message("This is an assertion condition.")
      
      # Handle assertions cause by a specific predicate
      if(e$predicate_name == "is_true")
      {
      }
    } else
    {
      # Handle other error types
    }
  }
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{strip_attributes}
\alias{strip_attributes}
\title{Strip all attributes from a variable}
\usage{
strip_attributes(x)
}
\arguments{
\item{x}{Input to strip.}
}
\value{
\code{x}, without attributes.
}
\description{
Strips all the attributes from a variable.
}
\examples{
x <- structure(c(foo = 1, bar = 2), some_attr = 3)
x2 <- strip_attributes(x)
attributes(x)
attributes(x2)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coercion.R
\name{coerce_to}
\alias{coerce_to}
\title{Coerce variable to a different class}
\usage{
coerce_to(x, target_class, .xname = get_name_in_parent(x))
}
\arguments{
\item{x}{Input to coerce.}

\item{target_class}{The desired class of x.  Multiple values allowed (see 
note).}

\item{.xname}{Not intended to be used directly.}
}
\value{
The input \code{x} after attempted coercion to the target class.
}
\description{
Coerce the input to a different class, with a warning.  More reliable then 
\code{\link[methods]{as}}, and supports coercion to multiple classes.
}
\note{
If x does not already have the target class, a warning is given
before coercion.  
The function will try and convert the \code{x} to each of the classes given
in \code{target_class}, in order, until it succeeds or runs out of classes
to try.  It will first try and convert \code{x} using a dedicated 
\code{as.target_class} function if that exists.  If it does not exist, or 
throws an error then \code{coerce_to} will try to use 
\code{as(x, target_class)}.
}
\examples{
# Numbers can be coerced to characters but not to calls.
dont_stop(coerce_to(1:5, c("call", "character")))
}
\seealso{
\code{\link[methods]{is}} and \code{\link[methods]{as}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cause.R
\name{cause}
\alias{cause}
\alias{cause<-}
\title{Get or set the \code{"cause"} attribute}
\usage{
cause(x)

cause(x) <- value
}
\arguments{
\item{x}{Any variable.}

\item{value}{Passed to \code{gettextf} and stored in the \code{"cause"}
attribute.}
}
\value{
The get method returns the \code{"cause"} attribute.
}
\description{
Gets or sets the \code{"cause"} (of failure) attribute of a variable.
}
\examples{
# Scalar case
yn <- is_identical_to_true(FALSE)
cause(yn)

# Vector case
yn <- is_true(c(TRUE, FALSE, NA))
cause(yn)
}
\seealso{
\code{\link{set_cause}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{get_name_in_parent}
\alias{get_name_in_parent}
\title{Get the name of a variable in the parent frame}
\usage{
get_name_in_parent(x, escape_percent = TRUE)
}
\arguments{
\item{x}{Variable to get the name of.}

\item{escape_percent}{Logical. If \code{TRUE}, percent signs are doubled, 
making the value suitable for use with \code{sprintf} (and hence by 
\code{false} and \code{na}).}
}
\value{
A string giving the name of the input in the parent frame.
}
\description{
Gets the name of the input in the parent frame.
}
\examples{
outside <- 1
f <- function(inside, escape_percent) 
{
  get_name_in_parent(inside, escape_percent)
}
f(outside, TRUE) 
f('10\%', TRUE) 
f('10\%', FALSE)
}
